package com.zcloud.modules.custormerInfo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zcloud.common.utils.PageUtils;
import com.zcloud.modules.custormerInfo.dao.BusAlifacoryDao;
import com.zcloud.modules.custormerInfo.entity.BusAlifacoryEntity;
import com.zcloud.modules.custormerInfo.service.BusAlifacoryService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;
import java.util.Map;

/**
 * @Author zhangyue
 * @Desc 阿里云转码模板(BusAlifacory)表服务实现类
 * @Date 2024-05-09 17:09:46
 */
@Service("busAlifacoryService")
public class BusAlifacoryServiceImpl extends ServiceImpl<BusAlifacoryDao, BusAlifacoryEntity> implements BusAlifacoryService {

    @Override
    public BusAlifacoryEntity queryByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusAlifacoryEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectOne(queryWrapper);
    }

    @Override
    public List<BusAlifacoryEntity> queryListByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusAlifacoryEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectList(queryWrapper);
    }

    @Override
    public PageUtils listPage(Map<String, Object> params) {
        Page<Map<String, Object>> page = new Page<>(Integer.parseInt(params.get("curPage").toString()), Integer.parseInt(params.get("limit").toString()));
        params.put("isDelete", 0);
        IPage<BusAlifacoryEntity> ipage = baseMapper.listPage(page, params);
        return new PageUtils(ipage);
    }


    @Override
    public void delete(String alifacoryId, String userId) {
        UpdateWrapper<BusAlifacoryEntity> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("alifacory_id", alifacoryId);

        BusAlifacoryEntity busAlifacory = new BusAlifacoryEntity();
        busAlifacory.setOperator(userId);
        busAlifacory.setIsDelete(1);

        this.update(busAlifacory, updateWrapper);
    }
}
